Qore Programming Language: QoreTypeSafeReferenceHelper Class Reference

Qore Programming Language 0.8.11

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Public Member Functions | List of all members
QoreTypeSafeReferenceHelper Class Reference

helper class to manage variable references passed to functions and class methods, stack only, cannot be dynamically allocated More...

`#include <QoreTypeSafeReferenceHelper.h>`

## Public Member Functions
DLLEXPORT | QoreTypeSafeReferenceHelper (const ReferenceNode *ref, ExceptionSink *xsink)
| initializes the object and tries to get the pointer to the pointer of the lvalue expression target More...
DLLEXPORT | QoreTypeSafeReferenceHelper (const ReferenceNode *ref, AutoVLock &vl, ExceptionSink *xsink)
| initializes the object and tries to get the pointer to the pointer of the lvalue expression target More...
DLLEXPORT | ~QoreTypeSafeReferenceHelper ()
| destroys the object
DLLEXPORT int | assign (AbstractQoreNode *val)
| assigns a value to the reference, assumes the reference is valid More...
DLLEXPORT int | assign (AbstractQoreNode *val, ExceptionSink *xsink)
| assigns a value to the reference, assumes the reference is valid More...
DLLEXPORT int | assignBigInt (int64 v)
| assigns an integer value to the reference More...
DLLEXPORT int | assignFloat (double v)
| assigns an integer value to the reference More...
DLLEXPORT qore_type_t | getType () const
| returns the type of the reference's value More...
DLLEXPORT const char * | getTypeName () const
| returns the type name of the reference's value More...
DLLEXPORT AbstractQoreNode * | getUnique (ExceptionSink *xsink)
| returns a pointer to the value with a unique reference count (so it can be updated in place), assumes the reference is valid More...
DLLEXPORT const AbstractQoreNode * | getValue () const
| returns a constant pointer to the reference's value More...
DLLEXPORT | operator bool () const
| returns true if the reference is valid, false if not More...
DLLEXPORT void | swap (QoreTypeSafeReferenceHelper &other)
| swaps the values of two references

## Detailed Description

helper class to manage variable references passed to functions and class methods, stack only, cannot be dynamically allocated

Takes care of safely accessing ReferenceNode objects, for example when they are passed as arguments to a builtin function or method. Locks are automatically acquired in the constructor if necessary and released in the destructor. The constructor could raise a Qore-language exception if there is a deadlock acquiring any locks to access the ReferenceNode's value as given by the lvalue expression, so the object should be checked for this state right after the constructor as in the following example:

const AbstractQoreNode *p = get_param(params, 0);
if (p && p->getType() == NT_REFERENCE) {
const ReferenceNode *r = reinterpret_cast<const ReferenceNode *>(p);
QoreTypeSafeReferenceHelper ref(r, xsink);
// a deadlock exception occurred accessing the reference's value pointer
if (!ref)
return 0;
// more code to access the reference
}

## Constructor & Destructor Documentation

DLLEXPORT QoreTypeSafeReferenceHelper::QoreTypeSafeReferenceHelper | ( | const ReferenceNode * | ref,
|  | ExceptionSink * | xsink
| ) |  |

initializes the object and tries to get the pointer to the pointer of the lvalue expression target

Parameters

  ref | the ReferenceNode to use
  xsink | Qore-language exceptions raised will be added here (for example, a deadlock accessing the object)

DLLEXPORT QoreTypeSafeReferenceHelper::QoreTypeSafeReferenceHelper | ( | const ReferenceNode * | ref,
|  | AutoVLock & | vl,
|  | ExceptionSink * | xsink
| ) |  |

initializes the object and tries to get the pointer to the pointer of the lvalue expression target

Parameters

  ref | the ReferenceNode to use
  vl | this argument is ignored in this deprecated version of the function
  xsink | Qore-language exceptions raised will be added here (for example, a deadlock accessing the object)

Deprecated:
  the AutoVLock argument is ignored in this deprecated version

## Member Function Documentation

DLLEXPORT int QoreTypeSafeReferenceHelper::assign | ( | AbstractQoreNode * | val | ) |

assigns a value to the reference, assumes the reference is valid

Parameters

  val | the value to assign (must be already referenced for the assignment)

Returns
  0 if there was no error and the variable was assigned, -1 if a Qore-language exception occured dereferencing the current value, in this case no assignment was made and the reference count for val is dereferenced automatically by the QoreTypeSafeReferenceHelper object

Note
  you must check that the reference is valid before calling this function
  QoreTypeSafeReferenceHelper rh(ref, xsink);
  // if the reference is not valid, then return
  if (!rh)
  return;
  // make the assignment (if the assignment fails, the value will be dereferenced automatically)
  rh.assign(val->refSelf());

DLLEXPORT int QoreTypeSafeReferenceHelper::assign | ( | AbstractQoreNode * | val,
|  | ExceptionSink * | xsink
| ) |  |

assigns a value to the reference, assumes the reference is valid

Parameters

  val | the value to assign (must be already referenced for the assignment)
  xsink | this argument is ignored; the ExceptionSink argument used in the constructor is used instead

Returns
  0 if there was no error and the variable was assigned, -1 if a Qore-language exception occured dereferencing the current value, in this case no assignment was made and the reference count for val is dereferenced automatically by the QoreTypeSafeReferenceHelper object

Note
  you must check that the reference is valid before calling this function
  QoreTypeSafeReferenceHelper rh(ref, xsink);
  // if the reference is not valid, then return
  if (!rh)
  return;
  // make the assignment (if the assignment fails, the value will be dereferenced automatically)
  rh.assign(val->refSelf());

Deprecated:
  use QoreTypeSafeReferenceHelper::assign(AbstractQoreNode *val) instead

DLLEXPORT int QoreTypeSafeReferenceHelper::assignBigInt | ( | int64 | v | ) |

assigns an integer value to the reference

Parameters

  v | the value to assign

Returns
  0 if there was no error and the variable was assigned, -1 if a Qore-language exception occured dereferencing the current value, in this case no assignment was made

DLLEXPORT int QoreTypeSafeReferenceHelper::assignFloat | ( | double | v | ) |

assigns an integer value to the reference

Parameters

  v | the value to assign

Returns
  0 if there was no error and the variable was assigned, -1 if a Qore-language exception occured dereferencing the current value, in this case no assignment was made

DLLEXPORT qore_type_t QoreTypeSafeReferenceHelper::getType | ( |  | ) | const

returns the type of the reference's value

Returns
  the type of the reference's value

DLLEXPORT const char* QoreTypeSafeReferenceHelper::getTypeName | ( |  | ) | const

returns the type name of the reference's value

Returns
  the type name of the reference's value

DLLEXPORT AbstractQoreNode* QoreTypeSafeReferenceHelper::getUnique | ( | ExceptionSink * | xsink | ) |

returns a pointer to the value with a unique reference count (so it can be updated in place), assumes the reference is valid

Parameters

  xsink | required for the call to AbstractQoreNode::deref()

Returns
  a pointer to the reference's value with a unique reference count (so it can be modified), or 0 if the value was 0 to start with or if a Qore-language exception was raised

Note
  you must check that the reference is valid before calling this function
  take care to only call this function on types where the AbstractQoreNode::realCopy() function has a valid implementation (on all value types suitable for in-place modification this function has a valid implementation), as in debugging builds other types will abort(); in non-debugging builds this function will simply do nothing
  QoreTypeSafeReferenceHelper rh(ref, xsink);
  // if the reference is not valid, then return
  if (!rh)
  return;
  // get the unique value
  AbstractQoreNode *val = rh.getUnique(xsink);
  // if a Qore-language exception was raised, then return
  if (*xsink)
  return;

DLLEXPORT const AbstractQoreNode* QoreTypeSafeReferenceHelper::getValue | ( |  | ) | const

returns a constant pointer to the reference's value

Returns
  the value of the lvalue reference (may be 0)

DLLEXPORT QoreTypeSafeReferenceHelper::operator bool | ( |  | ) | const

returns true if the reference is valid, false if not

false will only be returned if a Qore-language exception was raised in the constructor

The documentation for this class was generated from the following file:

- include/qore/QoreTypeSafeReferenceHelper.h (6585)